Bug 16873 - Renewal error message not specific enough on self check.
Summary: Renewal error message not specific enough on self check.
Status: Pushed to Stable
Alias: None
Product: Koha
Classification: Unclassified
Component: Self checkout (show other bugs)
Version: master
Hardware: All All
: P5 - low normal (vote)
Assignee: Jonathan Druart
QA Contact: Testopia
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2016-07-07 19:01 UTC by Barton Chittenden
Modified: 2016-11-29 23:12 UTC (History)
5 users (show)

See Also:
Change sponsored?: ---
Patch complexity: ---
Bot Control: ---
When did the bot last check this:
Who signed the patch off:
Text to go in the release notes:


Attachments
Bug 16873: Improve renewal error messages on self check (5.90 KB, patch)
2016-08-19 11:17 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 16873: Improve renewal error messages on self check (5.94 KB, patch)
2016-09-12 15:24 UTC, Jonathan Druart
Details | Diff | Splinter Review
[SIGNED-OFF] Bug 16873: Improve renewal error messages on self check (6.05 KB, patch)
2016-10-19 21:09 UTC, Josef Moravec
Details | Diff | Splinter Review
[SIGNED-OFF] Bug 16873: Improve renewal error messages on self check (6.06 KB, patch)
2016-11-06 20:15 UTC, Josef Moravec
Details | Diff | Splinter Review
[PASSED QA] Bug 16873: Improve renewal error messages on self check (6.11 KB, patch)
2016-11-20 19:34 UTC, Katrin Fischer
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Barton Chittenden 2016-07-07 19:01:16 UTC
Scenario:

An item is set to auto-renew. The borrower uses Koha's web based self-check terminal to renew the item, but gets the error message "This book cannot be renewed" when he/she tries to renew the item, rather than a more specific message like "This item is set for auto-renewal". This is confusing to the borrower, who thinks that the item has not and cannot be renewed.
Comment 1 Jonathan Druart 2016-08-19 11:17:00 UTC Comment hidden (obsolete)
Comment 2 Owen Leonard 2016-09-09 17:56:17 UTC
> 1/ check in an item and tick "auto renewal"
> 3/ check in an item and tick "on-site checkout"
> 5/ check in an item without ticking any checkboxes (regular checkout)

In these steps you mean 'check out' don't you?

When I test this I see the "This is a on-site checkout" message for my on-site checkout, but for the item which is set for auto-renewal I don't see the right message. I just see "No renewals allowed."

It looks like the template needs to check for 'auto_too_soon' as well as 'auto_renew'.
Comment 3 Jonathan Druart 2016-09-12 15:24:48 UTC
Created attachment 55503 [details] [review]
Bug 16873: Improve renewal error messages on self check

When a patron is not allowed to renew from the self check module, the
only message displayed is "No renewals allowed".
It would be nicer to let him/her know that the renewal is not allowed
because it's a on-site checkout or automatic renewal.

To do so we can call CanBookBeRenewed instead of CanBookBeIssued and get
the renewal error.

Test plan:
0/ Switch off AllowSelfCheckReturns
1/ check out an item and tick "auto renewal"
2/ Go on the self check module
=> auto renewal message is displayed
3/ check out an item and tick "on-site checkout"
4/ Go on the self check module
=> on-site checkout message is displayed
5/ check out an item without ticking any checkboxes (regular checkout)
Renew it to reach the max renew allowed
6/ Go on the self check module
=> regular checkout message is displayed
7/ Switch on AllowSelfCheckReturns and repeat previous steps
=> "Return this item" button is displayed in addition of the renewal
error message
Comment 4 Jonathan Druart 2016-09-12 15:25:16 UTC
(In reply to Owen Leonard from comment #2)
> > 1/ check in an item and tick "auto renewal"
> > 3/ check in an item and tick "on-site checkout"
> > 5/ check in an item without ticking any checkboxes (regular checkout)
> 
> In these steps you mean 'check out' don't you?
> 
> When I test this I see the "This is a on-site checkout" message for my
> on-site checkout, but for the item which is set for auto-renewal I don't see
> the right message. I just see "No renewals allowed."
> 
> It looks like the template needs to check for 'auto_too_soon' as well as
> 'auto_renew'.

Yes and Yes :)
Thanks for testing!
Comment 5 Josef Moravec 2016-10-19 21:09:46 UTC
Created attachment 56678 [details] [review]
[SIGNED-OFF] Bug 16873: Improve renewal error messages on self check

When a patron is not allowed to renew from the self check module, the
only message displayed is "No renewals allowed".
It would be nicer to let him/her know that the renewal is not allowed
because it's a on-site checkout or automatic renewal.

To do so we can call CanBookBeRenewed instead of CanBookBeIssued and get
the renewal error.

Test plan:
0/ Switch off AllowSelfCheckReturns
1/ check out an item and tick "auto renewal"
2/ Go on the self check module
=> auto renewal message is displayed
3/ check out an item and tick "on-site checkout"
4/ Go on the self check module
=> on-site checkout message is displayed
5/ check out an item without ticking any checkboxes (regular checkout)
Renew it to reach the max renew allowed
6/ Go on the self check module
=> regular checkout message is displayed
7/ Switch on AllowSelfCheckReturns and repeat previous steps
=> "Return this item" button is displayed in addition of the renewal
error message

Signed-off-by: Josef Moravec <josef.moravec@gmail.com>
Comment 6 Josef Moravec 2016-10-19 21:11:16 UTC
Everything works as described. 

I've rebased on the master.
Comment 7 Katrin Fischer 2016-11-06 10:53:40 UTC
There is a small conflict, please fix!
Comment 8 Josef Moravec 2016-11-06 20:15:41 UTC
Created attachment 57238 [details] [review]
[SIGNED-OFF] Bug 16873: Improve renewal error messages on self check

When a patron is not allowed to renew from the self check module, the
only message displayed is "No renewals allowed".
It would be nicer to let him/her know that the renewal is not allowed
because it's a on-site checkout or automatic renewal.

To do so we can call CanBookBeRenewed instead of CanBookBeIssued and get
the renewal error.

Test plan:
0/ Switch off AllowSelfCheckReturns
1/ check out an item and tick "auto renewal"
2/ Go on the self check module
=> auto renewal message is displayed
3/ check out an item and tick "on-site checkout"
4/ Go on the self check module
=> on-site checkout message is displayed
5/ check out an item without ticking any checkboxes (regular checkout)
Renew it to reach the max renew allowed
6/ Go on the self check module
=> regular checkout message is displayed
7/ Switch on AllowSelfCheckReturns and repeat previous steps
=> "Return this item" button is displayed in addition of the renewal
error message

Signed-off-by: Josef Moravec <josef.moravec@gmail.com>
Comment 9 Katrin Fischer 2016-11-20 19:34:51 UTC
Created attachment 57670 [details] [review]
[PASSED QA] Bug 16873: Improve renewal error messages on self check

When a patron is not allowed to renew from the self check module, the
only message displayed is "No renewals allowed".
It would be nicer to let him/her know that the renewal is not allowed
because it's a on-site checkout or automatic renewal.

To do so we can call CanBookBeRenewed instead of CanBookBeIssued and get
the renewal error.

Test plan:
0/ Switch off AllowSelfCheckReturns
1/ check out an item and tick "auto renewal"
2/ Go on the self check module
=> auto renewal message is displayed
3/ check out an item and tick "on-site checkout"
4/ Go on the self check module
=> on-site checkout message is displayed
5/ check out an item without ticking any checkboxes (regular checkout)
Renew it to reach the max renew allowed
6/ Go on the self check module
=> regular checkout message is displayed
7/ Switch on AllowSelfCheckReturns and repeat previous steps
=> "Return this item" button is displayed in addition of the renewal
error message

Signed-off-by: Josef Moravec <josef.moravec@gmail.com>

Signed-off-by: Katrin Fischer  <katrin.fischer@bsz-bw.de>
Comment 10 Katrin Fischer 2016-11-20 19:36:44 UTC
Beware: contains string changes!

Could also be updated to tell if an item can no longer be auto-renewed (see Bug 15581 - Add a circ rule to not allow auto-renewals after defined loan period)
Comment 11 Kyle M Hall 2016-11-29 17:44:21 UTC
Pushed to master for 17.05, thanks Jonathan!
Comment 12 Katrin Fischer 2016-11-29 23:12:37 UTC
This patch has been pushed to 16.11.x, will be in 16.11.01!